: <<canvas.f>> ;
CR
FLOAD canvasinc.f
( sample canvas )
VARIABLE hDC
VARIABLE hMemDC
VARIABLE hCanvas
VARIABLE hBitmap
VARIABLE hOldBitmap
VARIABLE LASTCANVAS
VARIABLE THISCANVAS

\ hMemDC stored in first cell of extra byte 
: MEMDC ( -- hMemDC) hCanvas @ 0 GetWindowLongA ;
\ MEMDC point to current canvas, select current canvas by click the canvas
: SETMEMDC ( hMemDC -- ) >R hCanvas @ 0 R> SetWindowLongA DROP ;

\ oldBitmap (1x1 b/w) stored in second cell of extra byte
: OLDBITMAP ( -- hBitmap ) hCanvas @ 4 GetWindowLongA ;
: SETOLDBITMAP ( hBitmap -- ) >R hCanvas @ 4 R> SetWindowLongA DROP ;

CREATE PAINTSTRUCT $40 ALLOT
(   HDC  hdc; 
    BOOL fErase; 
    RECT rcPaint; 
    BOOL fRestore; 
    BOOL fIncUpdate; 
    BYTE rgbReserved[32]; )

: FREEMEMDC
  MEMDC DUP OLDBITMAP SelectObject    \ unselect the bitmap
  DeleteObject DROP               \ delete the bitmap
  DeleteDC DROP
;
: update
  hCanvas @ RECT GetClientRect DROP
  hCanvas @ RECT 0 InvalidateRect DROP
;

: clearcanvas
  MEMDC WHITE_BRUSH GetStockObject SelectObject DROP
  MEMDC 0 0 RECT.RIGHT @ RECT.BOTTOM @ Rectangle DROP
  update
;
: CREATEMEMDC ( -- )
  hCanvas @ RECT GetClientRect DROP
  hCanvas @ GetDC hDC !
  hDC @ CreateCompatibleDC  SETMEMDC 
  hDC @ RECT.RIGHT @ RECT.BOTTOM @ CreateCompatibleBitmap  hBitmap !
  MEMDC hBitmap @ SelectObject  SETOLDBITMAP
  hCanvas @ hDC @ ReleaseDC DROP
  MEMDC 7 GetStockObject SelectObject DROP
  clearcanvas
;

: CANVASONCREATE
  CREATEMEMDC
;

: CANVASPROC ( hCanvas uMsg wParam lParam -- res )
  GETMSGWLPARAM hCanvas !
  MEMDC THISCANVAS !
  uMsg @ WM_PAINT = IF
      hCanvas @ PAINTSTRUCT BeginPaint hDC !
      hCanvas @ RECT GetClientRect DROP 
      hDC @ 0 0 RECT.RIGHT RECT.BOTTOM MEMDC 0 0 SRCCOPY BitBlt DROP
      hCanvas @ PAINTSTRUCT EndPaint DROP
      0 EXIT
      
  THEN
  
  uMsg @ WM_DESTROY = IF
    FREEMEMDC
    hCanvas @ REMOVEFROMLINK
  THEN
  
  hCanvas @ uMsg @ wParam @ lParam @ DefWindowProcA 
;

' CANVASPROC MESSAGEHANDLER: &CANVASPROC

: createCanvas ( x y w h -- hCanvas ) >r >r >r >r
  0 
  FORMCLASSNAMEA 
  Z" Canvas"                                 \ filename  as caption
  $10F80000
\ $0 0 $200 $300      \ width = $100 , height= $100
  r> r> r> r>
  0
  0
  HINST @
  0
  CreateWindowExA dup hCanvas ! >R
  
  R@ LASTCANVAS INSERTTOLINK CANVASONCREATE
  R@ GWL_WNDPROC &CANVASPROC SetWindowLongA DROP
  R@ WM_SIZE 0 0 SendMessageA DROP R> ;

: newcanvas ( -- ) 0 0 $200 $2C0 createCanvas drop ;

exit

: circle 
  MEMDC GRAY_BRUSH GetStockObject SelectObject DROP
  >R >R >R >R
  MEMDC R> R> R> R> Ellipse DROP
;


: rectangle ( x y w h -- )
  MEMDC GRAY_BRUSH GetStockObject SelectObject DROP
  >R >R >R >R
  MEMDC R> R> R> R> Rectangle DROP
;

: testdraw 
  10 10 20 20 circle
  10 10 30 30 circle
  10 10 40 40 circle
  10 10 50 50 circle
  10 10 60 60 circle
  update
;