anew <<crc-32.f>>

\ Wil Baden 2001-10-22
\ p CRC,  Forth,  Byte Table d, MĲv
\ Ѧ http://home.earthlink.net/~neilbawd/crc32.html

\ Probably it is INVERTed just for display (to be written down).
\ For the next calculation, it is inverted again.
\ I prefer to have -1 (true for Forth) for check,
\   crcok ( c-addr u -- flag )

\ crc-32.f for Win32Forth
\ ported to WinEf 2002-06-14 Sam Suan Chen

only new

' $" alias s"

code crc32 ( crc char -- crc' )
  mov	edx , 0 [ebp]
  lea	ebp , 4 [ebp]		\ pop crc to edx
  mov	ecx , # 8		\ loop count
@@1:
  shr	edx , # 1		\ shift crc
  rcr	bh , # 1
  ror	bl , # 1		\ shift character
  mov	ax , bx			\ save character
  xor	bl , bh			\ xor
  jns	short @@2		\ skip if equal
  xor	edx , # $EDB88320	\ crc-32 polymial 1 04C1 1DB7
@@2:
  mov	bx , ax			\ restore character
  loop	@@1			\ next bit
  mov	ebx , edx		\ crc to tos
  ret
  end-code

\ calculate crc-32 for several strings
: CRC-32 ( crc addr u -- crc' )
  BOUNDS 
  ?DO ( crc) I C@ crc32
  LOOP ;

: crcOk ( adr u -- flag )
  true -rot crc-32 ;

\ append crc to string
: CRC-MOVE ( crc addr -- )
  4 BOUNDS 
  DO ( crc) dup  255 AND  I C!  8 RSHIFT
  LOOP DROP ;

: CRC-TEST ( str len -- )
  pad cell+ place 
  0 pad cell+ count
  CRC-32		( crc )
  CR ." \ " HEX dup U. DECIMAL
  pad !
  pad @ pad 4
  CRC-32
  HEX U. DECIMAL        ( )  \  Should be 0.
  ;

S" An Arbitrary String" CRC-TEST
S" ZYXWVUTSRQPONMLKJIHGFEDBCA" CRC-TEST

\ cr unused u. .( bytes free. )
\ key bye
\ end of application, - do not delete -