anew <<find.f>>

code (cmpIns1)	\ compare the character at esi with that at edi, through al
	mov	al , [esi]	\ set al as the current char pointed by esi
	cmp	al , # ascii a
	jb	short @@1	\ skip to @@3, if al < 'a'
	cmp	al , # ascii z
	ja	short @@1	\ skip tp @@3, if al > 'z'
	sub	al , # 20	\ set al as the upper case char
@@1:	push	eax		\ keep al on return stack
	mov	al , [edi]	\ set al as the current char pointed by edi
	cmp	al , # ascii a
	jb	short @@2	\ skip to @@4, if al < 'a'
	cmp	al , # ascii z
	ja	short @@2	\ skip to @@4, if al > 'z'
	sub	al , # 20
@@2:	cmp	al , [esp]	\ compare this pair of characters
	pop	eax
	ret
	end-code

code (cmpIns)	\ compare string of len ecx at esi with that at edi, through al
@@1:	call	' (cmpIns1)
	jne	short @@2	\ go to next na, if the characters not identical
	inc	esi		\ esi points to its next character
	inc	edi		\ edi points to its next character
	loop	@@1		\ go to compare next pair of characters
@@2:	or	ecx, ecx
	ret
	end-code

code (find) ( zString va -- ca na | zString 0 )
	xor	edx , edx	\ set edx = 0, for case sensitive search first
\ -----------------------------------------------------------------------------
	xor	ecx , ecx
	dec	ecx		\ set ecx = -1 as initial counter value
	mov	edi , [ebp]	\ set edi to start the scan of zString
	xor	eax , eax	\ set eax for matching the char NULL (0)
	repnz	scasb		\ fast scan until NULL
	not	ecx		\ set ecx as the Length including NULL
\ -----------------------------------------------------------------------------
	mov	ebx , [ebx]	\ set ebx as the last na of given vocabulary va
	push	ebx		\ keep a copy of ebx on return stack
@@1:
	or	ebx , ebx
	je	short @@5	\ not found if no more na
	inc	ebx		\ set ebx as the zString of current na
\ -----------------------------------------------------------------------------
	mov	edi , ebx	\ set edi as the zString of current na
	mov	esi , [ebp]	\ set esi as the zString given
\ -----------------------------------------------------------------------------
	push	ecx		\ keep Length of zString on return stack
	or	edx , edx
	jne	short @@2	\ go to case insensitive compare, if edx not 0
	repz	cmpsb		\ compare these 2 zStrings in case sensitive
	jmp	short @@3
@@2:	call	' (cmpIns)	\ compare these 2 zStrings in case insensitive
@@3:	pop	ecx		\ always keep ecx as Length of zString
\ -----------------------------------------------------------------------------
	je	short @@4	\ found if all characters matched
	mov	ebx , -5 [ebx]	\ set ebx as the next na
	jmp	short @@1
\ -----------------------------------------------------------------------------
@@4:	mov	[ebp] , edi	\ replace zString as the current ca
	dec	ebx		\ put the current na on stack
	jmp	short @@6
\ -----------------------------------------------------------------------------
@@5:	or	edx , edx
	jnz	short @@6	\ no more searching, if already search twice
	add	edx , CAP
	je	short @@6	\ if CAP zero, no need case insensitive search
\ -----------------------------------------------------------------------------
	pop	ebx
	push	ebx		\ reload ebx as the last na
	jmp	short @@1	\ search again for case insensitive search
\ -----------------------------------------------------------------------------
@@6:	pop	eax		\ drop the last na on return stack
	ret
	end-code

CODE find ( nString va -- ca na | nString 0 )
	inc	[ebp]
	call	' (find)
	jne	@@1
	dec	[ebp]
@@1:	ret
	end-code

code search-wordlist ( StringAddr StringCount va -- ca na | 0 )
	lea	ebp , 4 [ebp]
	call	' (find)
	or	ebx, ebx
	jne	short @@1
	lea	ebp , 4 [ebp]
@@1:	ret
	end-code
