: <<see.f>> ; ( words vocabulary see 24feb02 ~ 27apr02 SamChen )
  only
  vocabulary decompiler  vocabulary disassembler
  decompiler definitions

: in-forth        only new also disassembler also decompiler ;
: in-decompiler   only new also disassembler also decompiler definitions ;
: in-disassembler only new also disassembler definitions also decompiler ;
  
in-forth also asm-hidden 
variable masmFormat 

\ ======================================================================= \ \
  create  ArrayDoneList 0 , \ the first 0 reserved as link list           \ \
  ' doVAR ,  
  0 , \ the last 0 used as the end-of-list                                \ \

  create StringDoneList 0 , \ the first 0 reserved as link list           \ \
  0 , \ the last 0 used as the end-of-list                                \ \
  
  create  CellsDoneList 0 , \ the first 0 reserved as link list           \ \
  ' doCALLBACK , ' doUSER , ' doVAR ,                                     \ \
  doVOC , doClinkCON , doCON , doVALUE , doDEFER , doSUBR , doOpcode ,    \ \
  doREF , doBIND , doMACRO-REF , doMACRO-BIND , doSEG-PRE , doINST-PRE ,  \ \
  doCONSOLECHILD , doASM-OP ,                                             \ \
  0 , \ the last 0 used as end-of-list                                    \ \

  create 1CallMoreList  0 , \ the first 0 reserved as link list           \ \
  | FORTH ' COMPILE , ' (+to) , ' (to) , ' (is) , ' compile ,             \ \
  0 , \ the last 0 used as end-of-list                                    \ \
  
  create 2CellMoreList  0 , \ the first 0 reserved as link list           \ \
  ' doWINAPI , 
  0 , \ the last 0 used as the end-of-list                                \ \
  
  create 1AddrMoreList  0 , \ the first 0 reserved as link list           \ \
  ' branch , ' ?branch , ' doNext , ' (do) , ' (?do) , ' (loop) ,         \ \
  ' (+loop) , ' (of) , ' (endof) , 
  0 , \ the last 0 used as the end-of-list                                \ \

  create 1CellMoreList  0 , \ the first 0 reserved as link list           \ \
  ' doLIT , 
  0 , \ the last 0 used as the end-of-list                                \ \
  
  create StringMoreList 0 , \ the first 0 reserved as link list           \ \
  ' doabort" , ' ."| , ' $"| , ' Z"| ,                                    \ \
  0 , \ the last 0 used as the end-of-list                                \ \
\ ======================================================================= \ \
previous

  
in-decompiler
: DUMMY ( -- ) HERE CELL+ 0 OVER ! DUP LAST ! \ create a null name
  CURRENT @ @  OVER CELL- !  COUNT + 1+  CP ! \ link to current vocabulary
  OVERT ;
in-forth

: addToList ( ca list -- ) dummy here swap dup @ , ! , ;
  
in-decompiler

  VARIABLE branch_target  VARIABLE branch_ca  VARIABLE done
  VARIABLE code_limit     VARIABLE indent     VARIABLE next_pc
  VARIABLE code_start     VARIABLE curr_pc    VARIABLE non_branch

  0 VALUE step_depth

: .indent indent @ spaces ;
: -indent indent @ 2- spaces ;
: >indent .indent 2 indent +! ;
: <indent -2 indent +! .indent ;
: h8.r ( a -- ) BASE @ >R HEX 0 <# # # # # # # # # #> TYPE R> BASE ! ;  \ ansi # 02jul02sam
in-forth
: .name ( ca -- ) >name .id ;
: h. ( n -- ) BASE @ >R HEX 1 .r R> BASE ! ;
: n. ( a -- ) dup UP DEFTIB $80 + within
  if ." UP " UP - h. ."  +" exit
  then dup name&voc
  if ( ca na va ) rot ." ( " h. ."  ) | "
     ( na va ) cell- body> .name ( na ) ."  ' " .id exit
  then ( a a ) body> name&voc
  if ( a na va ) 2 pick ." ( " h. ."  ) | " ( a na va ) 
     cell- body> .name swap ( na a ) @PreRel32BitAddr ['] doVAR =
     if space .id exit
     then ."  ' " .id ."  >body" exit
  then drop ( a ) CLINK
  BEGIN @ ( ca la ) ?DUP
  WHILE 2DUP CELL- @ =
     IF swap ." ( " h. ."  ) | " CELL- BODY> name&voc drop
        cell- body> .name space .id exit
     THEN 
  REPEAT h. ;

: showList ( list -- ) dup
  begin @ ?dup
  while cr dup cell- dup . @ n.
  repeat cell+
  begin dup @ ?dup
  while cr over . n. cell+
  repeat drop ;

in-decompiler
: a. ( a -- a ) DUP CR ." ( " h8.r ;
: b. ( v -- )
  BASE @ >R HEX SPACE 0 <# # # #> TYPE R> \ ansi # 02jul02sam
  BASE ! ;
: 0m. ( a -- a ) a. $10 spaces ." ) " ;
: m. ( a n -- a+n ) 1- 
  FOR DUP C@ b. 1+
  NEXT ;

: cr. ."  )" a. ;

: indentspaces ( n -- ) SPACES ."  ) " indent @ DUP + SPACES ;
: 0mm. ( a -- a ) $10 spaces ." ) " ;
: mm. ( a i n -- a+n ) 2DUP <
  IF OVER - >R m. ."  )" R> ( a' n-i ) 
     BEGIN 5 OVER <
     WHILE >R dup dup body> 5 matchString
        IF a. 5 m. ."  )"
        ELSE dup dup body> body> 5 matchString
           IF cr ." \ ..." 
           THEN >body
        THEN R> body>
     REPEAT >R a. 5 R>
  THEN SWAP OVER - >R m. R> 3 * indentspaces ;

: i.  ( a -- a+1 i ) a. ( a ) DUP 1+ SWAP C@ DUP b. ( a+1 i ) ;
: c@. ( a -- a+1 ) DUP 1+ SWAP C@ b. ;
: s.  ( a -- a' ) i. $3F and 1+ 4 SWAP mm. ;
: q.  ( -- ) $22 EMIT ;

: inList? ( ca list -- ca f ) swap >r dup ( list list )
  BEGIN cell+ dup @ ( list a [a] ) ?dup
  WHILE r@ =
     IF ( list a ) nip r> swap ( ca a ) exit
     THEN
  REPEAT ( list a' ) DROP ( list )
  BEGIN @ dup
  WHILE ( a" ) dup cell+ @ r@ =
     IF ( a" ) r> swap ( ca a" ) exit
     THEN
  REPEAT R> swap ( ca 0 ) ;

in-disassembler
cr

  fload dis486pr.f \ <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

  FLOAD dis486.f   \ <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
in-forth


: .end-code
  indent off .LabelEntry masmFormat @ 0=
  IF cr a. 0mm. ." end-code" cr cr
  THEN DROP ;

: adr, ( ca a -- )    swap [ also assembler ] a; [ previous ] here cell+ - ,  ;
: lit, ( ca v -- )    swap [ also assembler ] a; [ previous ]  ,  ;
: str," ( ca <string> -- ) [ also assembler ] a; [ previous ] $," ;

in-decompiler

: masm_h. ( n -- ) ." 0" h. ." H" ;

: 1CellMore  (  a -- a+4 ) masmFormat @
  if @+ cr ."   DD " masm_h. exit
  then a. 5 4 mm. 8 spaces dup cell- @ n. ."  | FORTH lit, " ;

: 1AddrMore  (  a -- a+4 ) masmFormat @
  if @+ ( a+4 [a] ) over + ( a+4 target ) cr ."   DD " isLabel
     if ." offset " base-addr >name masm.id >Label type drop
     else over - masm_h.
     then exit
  then a. 5 4 mm. 8 spaces dup 
  cell- @ over + \ fixed for offset addressing 15jun02sam
  isLabel	
  IF ." ( " over h. ."  ) " >Label type drop
  else n.
  THEN ."  | FORTH adr, " ;

: StringMore ( a -- a+[a]+1 ) masmFormat @
  if cr ."   DB '" count type ." ',0" exit
  then DUP s. SWAP ." | FORTH str," q. SPACE count type q. space ;

: cells. ( limit start -- limit )
  begin 2dup >
  while 2dup - cell <
     if a. 2dup - 5 swap mm. 
     else dup @ over cell- @ -
        if a. 5 4 mm. dup cell- @ n. ."  | FORTH lit, " \ 20jun02sam
        else dup @ over cell- cell- @ -
           if cr ." \ ..."
           then cell+
        then       
     then
  repeat drop ;

: call. ( limit a a' -- limit a a" )
  @+ OVER + ( limit a a'+4 ca )

  ArrayDoneList inList?
  IF ( limit a a'+4 ca ) drop a. 5 3 pick pluck - dup >r mm. r> 8 spaces 
     h. ."  allot " exit
  then
  
  CellsDoneList inList?
  IF ( limit a a'+4 ca ) DROP pluck swap
     cells. done ON EXIT
  THEN

  StringDoneList inList?
  IF ( a+4 ca ) DROP StringMore done ON EXIT
  THEN

  StringMoreList inList?
  IF ( a+4 ca ) DROP StringMore EXIT
  THEN
  
  1CallMoreList inList?
  IF ( a+4 ca ) DROP inst EXIT
  THEN
  
  1CellMoreList inList?
  IF ( a+4 ca ) DROP 1CellMore exit
  THEN
  
  2CellMoreList inList?
  IF ( a+4 ca ) DROP 1CellMore 1CellMore exit
  THEN
  
  1AddrMoreList inList?
  IF ['] branch =
     IF non_branch OFF 
     THEN 1AddrMore ( a+8 ) 
     dup CELL- @ over + branch_target ! EXIT
  THEN DROP ;
  
in-forth
: dis1 ( a -- a' )
  dup ['] dup 6 matchString 0=
  if a. 5 6 mm. ." $push_ebx" exit
  then
  dup ['] drop 6 matchString 0=
  if a. 5 6 mm. ." $pop_ebx" exit
  then
  branch_ca OFF  branch_target OFF  non_branch ON 
  .LabelEntry ( a )
  dup inst ( a a' ) s-buf 1+ z" rep" 3 matchString 0=
  IF inst nip exit
  THEN
  
  swap count ( a' a+1 i ) 

  DUP $E8 = \ see if it's the CALL instruction
  IF ( a' a+1 i ) DROP ( a' a+1 ) call. nip EXIT
  THEN 

  DUP $E9 = \ see if it's a 32-bit relative addr jump instruction
  IF ( a' a+1 i ) 2DROP ( a' ) DUP @PreRel32BitAddr ( a' ca )
     DUP branch_target !  branch_ca !  non_branch OFF
     code_limit @ OVER <  branch_target @ @CurRelAddr ['] doNEXT = NOT AND
     IF done ON
     THEN EXIT
  THEN 
  
  DUP $EB = \ see if it's a  8-bit relative addr jump instruction
  IF ( a' a+1 i ) 2DROP ( a' )
     DUP @PreRel8BitAddr 
     DUP branch_target !  branch_ca !  non_branch OFF
     code_limit @ OVER <  branch_target @ @CurRelAddr ['] doNEXT = NOT AND
     IF done ON
     THEN EXIT
  THEN ( a' a+1 i ) 2drop ;

: (dis) ( limit a -- ) setlabels ( limit a ) srtLabels 2 indent !
  BEGIN dis1 ( limit a' )
     ?wait 2dup =
  UNTIL .end-code drop ;

: dis ( a -- )
  begin inst ( a' ) key case
     ascii i of inst 0 endof
     ascii c of a. 5 4 mm. 0 endof
     ascii s of s. 0 endof
     $1B of -1 endof
     0 swap endcase
  until .end-code 1 abort" aborted" ;
     
: masm.head ( na va - ca ) drop ." $code 0" DUP C@ $C0 AND h. 
   ." H,'" DUP .ID ." '," dup masm.id name> ; 

: def.head ( na va - ca ) ." \ In vocabulary " vlink> .name 
  ( na ) cell- a. 5 4 mm. ." \ link to "
  ( na ) dup cell- @ .id
  ( na ) DUP s. swap 
  ( ca na ) ." code " DUP .ID ( ca na ) C@ DUP $80 AND
  IF ."  IMMEDIATE "
  THEN $40 AND
  IF ."  COMPILE-ONLY "
  THEN CR ;

: no.head ( -- ) ." \ There is no name for the following code:" CR ;


: (see) ( limit ca -- )  CR dup code_start !  dup code_limit ! ( limit ca )
  name&voc ( limit na va -1 | limit ca 0 )
  IF over w@ 0=
     if masmFormat @
        if 3drop exit
        then DROP a. 5 2 mm. ." | decompiler DUMMY" cells. cr cr drop exit
     then ( limit na va ) masmFormat @ ( limit na va flag )
     If  masm.head
     else def.head
     then
  ELSE no.head
  THEN ( limit ca ) (dis) ;

: seeInPad ( i -- ) cells naFirst + ( a )
  begin ( a' ) dup naLimit @ <
  while ( a' ) dup naFirst - cell/  dup $F and 0=
     if pause
     then cr ." \ " h. ( a' )
     dup cell+ @ cell- ( a' codeLimit )
     over @ name> ( a' codeLimit ca )
     (see) ( a' ) seeWaiting @
     if ( a' ) key dup [char] b =
        if ( a' k ) drop page cell- cell- ( a'-8 )
        else ( a' k ) $1B =
           abort" Aborted "
        then ( a" )
     then ( a" ) 
     dup @ [ ' COLD >NAME ] LITERAL = >R 
     \ the word DEBUG next to COLD in fsharp.asm is very important \ <========
     cell+ R>
     if begin dup @ [ ' <<extend.fex>> >NAME ] LITERAL <>
        while cell+
        repeat
     then
  repeat ( a' ) drop ;
  
: pad@ ( i -- v ) cells naFirst + @ ;

: see ( <name> -- ) allinpad bl word name? ?dup
  if ( ca na ) inPad ( ca na i ) nip ( ca i ) 
     dup 0< abort" cannot get its index " ( ca i )
     1+ cells naFirst + @ cell- ( ca limit )
     swap (see) exit
  then abort" cannot get its name address " ;
     
: seeAll ( -- ) AllInPad 0 seeInPad ;

.(   see.f Code Size:) HERE ' <<see.f>> - DECIMAL . .(  bytes) HEX  
