only anew <<source.f>>

new    also \ inString is in vocabulary new
hidden also \ hOpen hRead hClose are all in vocabulary hidden
forth

code matchString ( str ptn n -- str | 0 )
	mov	ecx , ebx
	mov	edi , [ebp]
	mov	esi , 4 [ebp]
	lea	ebp , 8 [ebp]
	mov	ebx , esi
\ ============================================================================
\ match str esi with ptn edi of len ecx (caseSensitive, if CAP 0)
\ ----------------------------------------------------------------------------
	cmp	CAP , # 0
	jne	short @@1	\ go to case insensitive compare, if edx not 0
	repz	cmpsb		\ compare these 2 zStrings in case sensitive
	jmp	short @@2
@@1:	call	' (cmpIns)	\ compare these 2 zStrings in case insensitive
@@2:
\ ----------------------------------------------------------------------------
	je	short @@3
	xor	ebx , ebx
@@3:	ret
	end-code

code InString ( string ns pattern np -- 0 | addr ) \ 06jun02sam
	mov	ecx , ebx	\ ecx = np
	push	ecx		\ push np to retuen stack \\\\\\\\\\\\\\\
	push	[ebp]		\ push pattern to return stack \\\\\\\\\\
	mov	eax , 4 [ebp]	\ eax = ns
	mov	edx , 8 [ebp]	\ edx = string \\\\\\\\\\\\\\\\\\\\\\\\\\
	lea	ebp , $C [ebp]	\ clear data stack
	xor	ebx , ebx	\ ebx = 0, the default return value
	sub	eax , ecx	\ eax = ns - np
@@1:	or	eax , eax
	jl	short @@5	\ return, if need no more matching
	dec	eax		\ decrement the loop counter
	mov	esi , edx	\ esi = string
	pop	edi		\ edi = pattern
	pop	ecx		\ ecx = np
	push	ecx		\ save np
	push	edi		\ save pattern
	push	eax		\ save the loop counter
\ ============================================================================
\ match str esi with ptn edi of len ecx (caseSensitive, if CAP 0)
\ ----------------------------------------------------------------------------
	cmp	CAP , # 0
	jne	short @@2	\ go to case insensitive compare, if edx not 0
	repz	cmpsb		\ compare these 2 zStrings in case sensitive
	jmp	short @@3
@@2:	call	' (cmpIns)	\ compare these 2 zStrings in case insensitive
@@3:
\ ============================================================================
	pop	eax
	je	short @@4	\ jmp @@4, if matched
	inc	edx		\ edx = next string
	jmp	short @@1	\ loop back
@@4:
	mov	ebx , edx	\ return addr found in string
@@5:
	lea	esp , 8 [esp]	\ clear return stack
	ret
	end-code

code type ( a n -- )
	mov	ecx , ebx
	mov	esi , [ebp]
	mov	ebx , 4 [ebp]
	lea	ebp , 8 [ebp]
@@1:	or	ecx , ecx
	jz	@@2
	lodsb
	lea	ebp , -4 [ebp]
	xor	ebx , ebx
	mov	bl , al
	push	ecx
	push	esi
	call	' emit
	pop	esi
	pop	ecx
	loop	@@1
@@2:	ret
	end-code

\ =============================================================================
: readToPad ( zString -- )
  hOpen ( hFile ) dup        0= abort" hOpen error "
  dup pad eod @ over - hRead 0= abort" hRead error " ( hFile )
  hclose                     0= abort" hClose error " ;

code parseLine ( a n -- a' n' a n-n' )
	mov	ecx , ebx
	mov	edi , [ebp]
	lea	ebp , -8 [ebp]
	mov	[ebp] , edi
	mov	eax , # $D
	repnz	scasb
	jne	@@1		\ skip the following code, if $D not found
	dec	ebx
	sub	ebx , ecx
	cmp	[edi] , byte # $A
	jne	@@1
	inc	edi
	dec	ecx
@@1:	mov	$8 [ebp] , edi
	mov	$4 [ebp] , ecx
	ret
	end-code

: selectLine? ( a n -- a n flag ) 0 ( a n 0 )
  pluck c@   [char] ;           =        ?exit
  pluckpluck s" LEX,NAME,LABEL" instring ?exit
  pluckpluck s" $USERPTR"       instring ?exit
  pluckpluck s" $USERVAR"       instring ?exit
  1- ( a n -1 )
  pluckpluck s" $code"  	inString ?exit
  pluckpluck s" $colon"         instring ?exit
  pluckpluck s" $user"          instring ?exit
  1+ ( a n 0 ) ;

  defer procLine
: defProcLine ( a n -- ) cr type ;
' defProcLine is procLine

\ =============================================================================
: grepAll ( -- ) allinpad  saFirst saLimit !
  z" \fsharp\src\fsharp.asm" ReadToPad pad #byteRead
  begin   ( a0 n0 ) ?dup
  while   ( a0 n0 ) parseLine ( a1 n1 a2 n2 ) selectLine?
     if   ( a1 n1 a2 n2 ) procLine ?wait
     else ( a1 n1 a2 n2 ) 2drop
     then
  repeat ;

\ =============================================================================
code skipBL ( a n -- a' n' | a+n 0 ) \ n'=0, if no match
	mov	ecx , ebx
	mov	edi , [ebp]
	mov	al , # $20
	repz	scasb
	jz	short @@1
	dec	edi
	inc	ecx
@@1:	mov	[ebp] , edi
	mov	ebx , ecx
	ret
	end-code

code skipTheChar ( a n c -- a' n' | a+n 0 ) \ n'=0, if no match
	mov	eax , ebx
	mov	ecx , [ebp]
	lea	ebp , 4 [ebp]
	mov	edi , [ebp]
	repz	scasb
	jz	short @@1
	dec	edi
	inc	ecx
@@1:	mov	[ebp] , edi
	mov	ebx , ecx
	ret
	end-code

code skipNotTheChar ( a n c -- a' n' | a+n 0 ) \ n'=0, if no match
	mov	eax , ebx
	mov	ecx , [ebp]
	lea	ebp , 4 [ebp]
	mov	edi , [ebp]
	repnz	scasb
	jnz	short @@1
	dec	edi
	inc	ecx
@@1:	mov	[ebp] , edi
	mov	ebx , ecx
	ret
	end-code

code skip1Char ( a n -- a+1 n-1 | a n ) \ nothing change, if n=0
	or	ebx , ebx
	jz	short @@1
	dec	ebx
	inc	[ebp]
@@1:	ret
	end-code

code skip#Char ( a n m -- a+m n-m | a+n 0 ) \ adjust m=n, if m>n
	mov	ecx , ebx
	$pop_ebx
	sub	ebx , ecx
	jge	@@1
	add	ecx , ebx
	xor	ebx , ebx
@@1:	add	[ebp] , ecx
	ret
	end-code
	
code pop1Char ( a n -- a+1 n-1 c | a 0 0 ) \ c=0, if n=0
	xor	eax , eax
	or	ebx , ebx
	jz	@@1
	mov	edi , [ebp]
	mov	al , [edi]
	inc	[ebp]
	dec	ebx
@@1:	$push_ebx
	mov	ebx , eax
	ret
	end-code
	
code parseString ( a n c -- a' n' a n-n' )
	mov	eax , ebx
	mov	ecx , [ebp]
	mov	ebx , ecx
	mov	edi , 4 [ebp]
	lea	ebp , -4 [ebp]
	mov	[ebp] , edi
	repnz	scasb
	jne	@@1		\ skip the following code, if char c not found
	inc	ecx
	dec	edi
	sub	ebx , ecx
@@1:	mov	$8 [ebp] , edi
	mov	$4 [ebp] , ecx
	ret
	end-code

code saLimit! ( na -- ) 
	mov	eax , ebx
	mov	edi , saLimit
	stosd
	mov	saLimit , edi
	$pop_ebx
	ret
	end-code

: <procLine> ( a n -- ) 
  cr saLimit @ saFirst - cell/ . \ --------------------------------
  [char] , skipNotTheChar ( a1 n1 ) skip1char 
  [char] , skipNotTheChar ( a2 n2 ) skip1Char skipBL 
  bl parseString ( a3 n3 a4 n4 )
  2dup space type \ -----------------------------------------------
  here cell+ dup>r ( a3 n3 a4 n4 h+4 ) 
  dup . \ ---------------------------------------------------------
  place ( a3 n3 ) r@ count + off ( a3 n3 )
  r@ $,n compile-only ( a3 n3 )
  r> saLimit! ( a3 n3 ) 2drop ;

' <procLine> is procLine
